#encoding 'UTF-8'

# functions to apply colors to terminal output

COLORS = {:default => 9, :black => 0, :red => 1, :green => 2, :yellow => 3, :blue => 4, :purple => 5, :cyan => 6, :white => 7 }

BG = 4
FG = 3
REGULAR = 0
BOLD = 1
UNDERLINE = 4
BLINK = 5
SWAP = 7
NEUTRAL = 0

STYLES = {:regular => REGULAR, :bold => BOLD, :underline => UNDERLINE, :blink => BLINK, :swap => SWAP, :neutral => NEUTRAL}

def colorize(text, color_code)
    "#{color_code}#{text}\033[0m"
end

def style(text, style_code)
  "#{style_code}#{text}\033[0m"
end

def colored_output(output_text, fg_color = :default, bg_color = :default, style = :regular , mode = :neutral )
  "\033[%i;%i;%i%i;%i%im%s\033[0m" %[STYLES[mode.to_sym], STYLES[style.to_sym], FG, COLORS[fg_color.to_sym], BG, COLORS[bg_color.to_sym], output_text]
end

def red(text); colorize(text, "\033[31m"); end
def green(text); colorize(text, "\033[32m"); end
def yellow(text); colorize(text, "\033[33m"); end
def purple(text); colorize(text, "\033[35m"); end
def cyan(text); colorize(text, "\033[36m"); end
def blue(text); colorize(text, "\033[34m"); end
def white(text); colorize(text, "\033[37m"); end

def black_on_white(text); colorize(colorize(text, "\033[30m"), "\033[47m");end
def white_on_black(text); colorize(colorize(text, "\033[37m"), "\033[40m");end

def bold(text); style(text, "\033[01m");end
def underline(text); style(text, "\033[04m");end

